<a id="mypy-boto3-snow-device-management"></a>

# mypy-boto3-snow-device-management

[![PyPI - mypy-boto3-snow-device-management](https://img.shields.io/pypi/v/mypy-boto3-snow-device-management.svg?color=blue)](https://pypi.org/project/mypy-boto3-snow-device-management)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-snow-device-management.svg?color=blue)](https://pypi.org/project/mypy-boto3-snow-device-management)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-snow-device-management?color=blue)](https://pypistats.org/packages/mypy-boto3-snow-device-management)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.SnowDeviceManagement 1.19.9](https://boto3.amazonaws.com/v1/documentation/api/1.19.9/reference/services/snow-device-management.html#SnowDeviceManagement)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.0.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-snow-device-management docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_snow_device_management/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-snow-device-management](#mypy-boto3-snow-device-management)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

Install `boto3-stubs` for `SnowDeviceManagement` service.

```bash
python -m pip install boto3-stubs[snow-device-management]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[snow-device-management]` in your environment:
  `python -m pip install 'boto3-stubs[snow-device-management]'`

Both type checking and auto-complete should work for `SnowDeviceManagement`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto-stubs[snow-device-management]` in your environment:
  `python -m pip install 'boto3-stubs[snow-device-management]'`

Both type checking and auto-complete should work for `SnowDeviceManagement`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[snow-device-management]` in your environment:
  `python -m pip install 'boto3-stubs[snow-device-management]'`
- Run `mypy` as usual

Type checking should work for `SnowDeviceManagement` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[snow-device-management]` in your environment:
  `python -m pip install 'boto3-stubs[snow-device-management]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `SnowDeviceManagement` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`SnowDeviceManagementClient` provides annotations for
`boto3.client("snow-device-management")`.

```python
import boto3

from mypy_boto3_snow_device_management import SnowDeviceManagementClient

client: SnowDeviceManagementClient = boto3.client("snow-device-management")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: SnowDeviceManagementClient = session.client("snow-device-management")
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_snow_device_management.paginator` module contains type annotations
for all paginators.

```python
from mypy_boto3_snow_device_management import SnowDeviceManagementClient
from mypy_boto3_snow_device_management.paginator import (
    ListDeviceResourcesPaginator,
    ListDevicesPaginator,
    ListExecutionsPaginator,
    ListTasksPaginator,
)

client: SnowDeviceManagementClient = boto3.client("snow-device-management")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_device_resources_paginator: ListDeviceResourcesPaginator = client.get_paginator("list_device_resources")
list_devices_paginator: ListDevicesPaginator = client.get_paginator("list_devices")
list_executions_paginator: ListExecutionsPaginator = client.get_paginator("list_executions")
list_tasks_paginator: ListTasksPaginator = client.get_paginator("list_tasks")
```

<a id="literals"></a>

### Literals

`mypy_boto3_snow_device_management.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

```python
from mypy_boto3_snow_device_management.literals import (
    AttachmentStatusType,
    ExecutionStateType,
    InstanceStateNameType,
    IpAddressAssignmentType,
    ListDeviceResourcesPaginatorName,
    ListDevicesPaginatorName,
    ListExecutionsPaginatorName,
    ListTasksPaginatorName,
    PhysicalConnectorTypeType,
    TaskStateType,
    UnlockStateType,
    ServiceName,
    PaginatorName,
)

def check_value(value: AttachmentStatusType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_snow_device_management.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_snow_device_management.type_defs import (
    CancelTaskInputRequestTypeDef,
    CancelTaskOutputTypeDef,
    CapacityTypeDef,
    CommandTypeDef,
    CpuOptionsTypeDef,
    CreateTaskInputRequestTypeDef,
    CreateTaskOutputTypeDef,
    DescribeDeviceEc2InputRequestTypeDef,
    DescribeDeviceEc2OutputTypeDef,
    DescribeDeviceInputRequestTypeDef,
    DescribeDeviceOutputTypeDef,
    DescribeExecutionInputRequestTypeDef,
    DescribeExecutionOutputTypeDef,
    DescribeTaskInputRequestTypeDef,
    DescribeTaskOutputTypeDef,
    DeviceSummaryTypeDef,
    EbsInstanceBlockDeviceTypeDef,
    ExecutionSummaryTypeDef,
    InstanceBlockDeviceMappingTypeDef,
    InstanceStateTypeDef,
    InstanceSummaryTypeDef,
    InstanceTypeDef,
    ListDeviceResourcesInputRequestTypeDef,
    ListDeviceResourcesOutputTypeDef,
    ListDevicesInputRequestTypeDef,
    ListDevicesOutputTypeDef,
    ListExecutionsInputRequestTypeDef,
    ListExecutionsOutputTypeDef,
    ListTagsForResourceInputRequestTypeDef,
    ListTagsForResourceOutputTypeDef,
    ListTasksInputRequestTypeDef,
    ListTasksOutputTypeDef,
    PaginatorConfigTypeDef,
    PhysicalNetworkInterfaceTypeDef,
    ResourceSummaryTypeDef,
    ResponseMetadataTypeDef,
    SecurityGroupIdentifierTypeDef,
    SoftwareInformationTypeDef,
    TagResourceInputRequestTypeDef,
    TaskSummaryTypeDef,
    UntagResourceInputRequestTypeDef,
)

def get_structure() -> CancelTaskInputRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-snow-device-management` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-snow-device-management docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_snow_device_management/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
